/*
 * aufgabe3.c
 *
 *  Created on: 14.01.2013
 *      Author: johann
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define REAL(Z)  (Z).re
#define IMAG(Z)  (Z).im
#define SETZE_REAL(Z, X) (Z).re = (X)
#define SETZE_IMAG(Z, X) (Z).im = (X)

#define PRINT_COMPLEX(_FMT_STR, Z, ...) \
  printf(_FMT_STR "% lf%+lfi\n", ##__VA_ARGS__, REAL((Z)), IMAG((Z)))

#define NEW_COMPLEX_POLAR(radius,winkel)	\
  {radius * cos(winkel), radius * sin(winkel)}

#define COMPLEX_PRODUCT(z1,z2)\
  {z1.re*z2.re - z1.im*z2.im, z1.re*z2.im + z1.im*z2.re}


typedef struct
{
  double re;
  double im;
} Complex;


/*******************/
/*  Hauptprogramm  */
/*******************/

int main(void)
{
  Complex z1 = {1.0, -1.0};
  
  double re1 = REAL(z1);
  double im1 = IMAG(z1);
  
  
  printf("z1 = % lf%+lfi\n", re1, im1);
  
  PRINT_COMPLEX("%s = ", z1, "z1");

  
  
  SETZE_REAL(z1, -2.5);
  SETZE_IMAG(z1, 0.125);
  
  
  
  Complex z2 = NEW_COMPLEX_POLAR(2.0, 3*M_PI/4.0);
  
  PRINT_COMPLEX("Die komplexe Zahl %s ist gleich ", z1, "z1");
  PRINT_COMPLEX("Die komplexe Zahl %s ist gleich ", z2, "z2");

  Complex z3 = COMPLEX_PRODUCT(z1,z2);
  
  PRINT_COMPLEX("Das Produkt von %s und %s ist gleich ", z3, "z1","z2");
  return 0;
}
